import java.io.*;
import java.util.*;

public class B {
    public void solve() throws IOException {
    	long k = nextLong();
    	long s = nextLong();
    	long s1 = s + k * (k + 1) / 2;
    	long l = 0;
    	long r = Integer.MAX_VALUE / 2;
    	while (l + 1 < r) {
			long m = (l + r) / 2;
			long x = m * (m + 1) / 2;
			if (x <= s1) {
				l = m;
			} else {
				r = m;
			}
		}
    	if (l * (l + 1) / 2 == s1) {
			System.out.println(k);
			return;
		}
    	long d = s1 - l * (l + 1) / 2;
    	System.out.println(k + (d + l - k - 1) / (l - k));
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in)); 
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new B().run();
    }

}
