import java.io.*;
import java.util.*;

public class D4 {
	
	public class Point implements Comparable<Point> {
		int x;
		int c;
		
		public Point(int x, int c) {
			this.x = x;
			this.c = c;
		}

		@Override
		public int compareTo(Point arg0) {
			return x - arg0.x;
		}
		
		
	}
	
//	public class Vertex {
//		int l;
//		int r;
//		Vertex left;
//		Vertex right;
//		int[] map = new int[m];
//		int color;
//		int[] lastAns = new int[m];
//		
//		public Vertex(Vertex left, Vertex right, int l, int r) {
//			this.left = left;
//			this.right = right;
//			this.l = l;
//			this.r = r;
//			int minl = Integer.MAX_VALUE;
//			int minr = Integer.MAX_VALUE;
//			int[] m1 = left.lastAns;
//			int[] m2 = right.lastAns;
//			for (int i = 0; i < m2.length; i++) {
////				System.out.println(left + " " + right + " " + m1[i] + " " + m2[i]);
//				minl = Math.min(minl, m1[i]);
//				minr = Math.min(minr, m2[i]);
//			}
//			for (int i = 0; i < map.length; i++) {
//				map[i] = left.map[i] + right.map[i];
//				lastAns[i] = Math.min(minl, m1[i] - 1) + Math.min(minr, m2[i] - 1) + 1;
////				System.out.println(this + " " + left + " " + right + " " + l + " " + r + " " + i + " " + Math.min(minl, m1[i] - 1) + " " + Math.min(minr, m2[i] - 1) + " " + minl + " " + minr);
////				lastAns[i] = left.lastAns[i] + right.lastAns[i] - 1;
//			}
//			int max = 0;
//			for (int i = 0; i < map.length; i++) {
//				if (map[i] > max) {
//					max = map[i];
//					color = i;
//				}
//			}
//		}
//		
//		public Vertex(int l, int r, int c) {
//			this.l = l;
//			this.r = r;
//			left = null;
//			right = null;
//			color = c;
//			map[c] = r - l + 1;
//			for (int i = 0; i < lastAns.length; i++) {
//				lastAns[i] = 2;
//			}
//			lastAns[c] = 1;
////			System.out.println(this + " " + l + " " + r + " " + c);
////			for (int i = 0; i < lastAns.length; i++) {
////				System.out.print(lastAns[i] + " ");
////			}
////			System.out.println();
////			System.out.println();
//		}
//	}
	
	public int[] build(int l, int r) {
		int[] a = new int[m];
		if (line[last + 1].x > r) {
			for (int i = 0; i < a.length; i++) {
				a[i] = 2;
			}
			a[line[last].c] = 1;
//			Vertex v = new Vertex(l, r, line[last].c);
			if (line[last + 1].x == r + 1) {
				last++;
			}
			return a;
		}
		int m = (l + r) / 2;
		int[] b = build(l, m);
		int[] c = build(m + 1, r);
		int minl = Integer.MAX_VALUE;
		int minr = Integer.MAX_VALUE;
		for (int i = 0; i < c.length; i++) {
			minl = Math.min(minl, b[i]);
			minr = Math.min(minr, c[i]);
		}
		for (int i = 0; i < a.length; i++) {
			a[i] = Math.min(minl, b[i] - 1) + Math.min(minr, c[i] - 1) + 1;
		}
		return a;
	}
	
//	public void out(Vertex v) {
//		System.out.println(v + " " + v.l + " " + v.r + " " + v.left + " " + v.right + " " + v.color);
//		for (int i = 0; i < v.map.length; i++) {
//			System.out.println(i + " " + v.map[i]);
//		}
//		for (int i = 0; i < v.lastAns.length; i++) {
//			System.out.println(v.lastAns[i]);
//		}
//		System.out.println();
//		if (v.left != null) {
//			out(v.left);
//			out(v.right);
//		}
//	}
	
//	public void get(Vertex v, int c) {
//		if (c < 0 || v.map[c] != v.map[v.color]) {
//			ans++;
//			c = v.color;
//		}
//		if (v.left == null) {
//			return;
//		}
//		get(v.left, c);
//		get(v.right, c);
//	}
	
	int k;
	int m;
	Point[] line;
	int last = 0;
//	Vertex root;
	int ans = Integer.MAX_VALUE;
	
    public void solve() throws IOException {
    	k = nextInt();
    	int n = nextInt();
    	m = nextInt();
    	int x = 0;
    	line = new Point[n + 1];
    	for (int i = 0; i < n; i++) {
			int c = nextInt();
			line[i] = new Point(x, nextInt() - 1);
			x += c;
		}
    	long l = System.currentTimeMillis();
    	line[n] = new Point(x, -1);
    	int[] a = build(0, (1 << k) - 1);
//    	out(root);
//    	get(root, -1);
//    	System.out.println(ans);
    	for (int i : a) {
			ans = Math.min(ans, i);
		}
    	System.out.println(ans);
//    	System.out.println(System.currentTimeMillis() - l);
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in) /*new FileReader(new File("input.txt"))*/); 
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new D4().run();
    }

}
