import java.io.*;
import java.util.*;

public class D5 {
	
	public class Point implements Comparable<Point> {
		int x;
		int c;
		
		public Point(int x, int c) {
			this.x = x;
			this.c = c;
		}

		@Override
		public int compareTo(Point arg0) {
			return x - arg0.x;
		}
	}
	
	public class buildReturn {
		HashSet<Integer> set;
		int ans;

		public buildReturn(HashSet<Integer> set, int ans) {
			this.set = set;
			this.ans = ans;
		}
	}
	
	public buildReturn build(int l, int r) {
		if (line[last + 1].x > r) {
			HashSet<Integer> set = new HashSet<>();
			set.add(line[last].c);
			if (line[last + 1].x == r + 1) {
				last++;
			}
			return new buildReturn(set, 1);
		}
		int m = (l + r) / 2;
		buildReturn b = build(l, m);
		buildReturn c = build(m + 1, r);
//		HashMap<Integer, Integer> map = new HashMap<>();
		HashSet<Integer> both = new HashSet<>();
		for (int i : b.set) {
			if (c.set.contains(i)) {
				both.add(i);
			}
//			map.put(i, b.ans + (c.set.contains(i) ? c.ans - 1 : c.ans));
		}
//		for (int i : c.set) {
//			if (!map.containsKey(i)) {
//				map.put(i, c.ans + b.ans);
//			}
//		}
//		int min = Integer.MAX_VALUE;
//		for (int i : map.keySet()) {
//			min = Math.min(min, map.get(i));
//		}
//		HashSet<Integer> set = new HashSet<>();
//		for (int i : map.keySet()) {
//			if (map.get(i) == min) {
//				set.add(i);
//			}
//		}
		int min = both.size() == 0 ? b.ans + c.ans : b.ans + c.ans - 1;
		if (both.size() == 0) {
			for (int i : b.set) {
				both.add(i);
			}
			for (int i : c.set) {
				both.add(i);
			}
		}
		return new buildReturn(both, min);
	}
	
	int k;
	int m;
	Point[] line;
	int last = 0;
	int ans = Integer.MAX_VALUE;
	
    public void solve() throws IOException {
    	k = nextInt();
    	int n = nextInt();
    	m = nextInt();
    	int x = 0;
    	line = new Point[n + 1];
    	for (int i = 0; i < n; i++) {
			int c = nextInt();
			line[i] = new Point(x, nextInt() - 1);
			x += c;
		}
    	line[n] = new Point(x, -1);
    	System.out.println(build(0, (1 << k) - 1).ans);
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in) /*new FileReader(new File("input.txt"))*/); 
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new D5().run();
    }

}
