import java.io.*;
import java.util.*;

public class A {
    public void solve() throws IOException {
    	long a = nextLong();
    	long b = nextLong();
    	long c = nextLong();
    	long min = Math.min(b, c);
    	b -= min;
    	c -= min;
    	long ans = 0;
    	if (c == 0) {
			ans += a;
			ans += (b + 2) / 3;
		} else {
			a -= c / 3;
			c %= 3;
			ans = Math.max(ans, a);
		}
    	out.print(ans);
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in)); 
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new A().run();
    }

}
