import java.io.*;
import java.util.*;

public class B {
    public void solve() throws IOException {
    	long a = nextLong();
    	long b = nextLong();
    	long k = nextLong();
    	long ans = 0;
    	for (long y = 1L; y * y * y <= b; y++) {
    		if (y * y * y < a) {
				continue;
			}
    		long l = 0;
    		long r = Integer.MAX_VALUE / 2;
    		while (l + 1 < r) {
				long m = (l + r) / 2;
				long sq = m * m;
				if (sq >= a && sq >= y * y * y - k) {
					r = m;
				} else {
					l = m;
				}
			}
    		long min = r;
    		l = 0;
    		r = Integer.MAX_VALUE / 2;
    		while (l + 1 < r) {
				long m = (l + r) / 2;
				long sq = m * m;
				if (sq <= b && sq <= y * y * y + k) {
					l = m;
				} else {
					r = m;
				}
			}
    		long max = l;
    		ans += Math.max(0, max - min + 1);
    	}
    	out.print(ans);
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in)); 
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new B().run();
    }

}
