import java.io.*;
import java.util.*;

public class D {

	public class Edge {
		int to;
		int l;
		int number;

		public Edge(int to, int l, int number) {
			this.to = to;
			this.l = l;
			this.number = number;
		}
	}
	
	public class Pair implements Comparable<Pair> {
		int len;
		long c;

		public Pair(int len, long c) {
			this.len = len;
			this.c = c;
		}

		@Override
		public int compareTo(Pair o) {
			if (c > o.c) {
				return 1;
			}
			if (c < o.c) {
				return -1;
			}
			return o.len - len;
		}
		
	}
	
	public TreeSet<Pair> dfs(int v) {
//		tin[v] = time;
//		time++;
		int n = numberInBor;
		long[] min = new long[edge[v].size() + 1];
		long sumMin = 0L;
		TreeSet<Pair>[] ost = new TreeSet[min.length];
		int iterator = 0;
		for (Edge e : edge[v]) {
			while (numberInBor >= 0 && to[numberInBor][e.l] == -1) {
				numberInBor = link[numberInBor];
			}
			if (numberInBor == -1) {
				System.out.println(-1);
				System.exit(0);
			} else {
				numberInBor = to[numberInBor][e.l];
				ost[iterator] = dfs(e.to);
//				System.out.println(v + " " + e.to);
				min[iterator] = ost[iterator].first().c;
				sumMin += ost[iterator].first().c;
//				left[v] = ans[v];
			}
			numberInBor = n;
			iterator++;
		}
		ans[v] = sumMin;
		int th = numberInBor;
		TreeSet<Pair> set = new TreeSet<>();
//		System.out.println(v + " " + numberInBor + " dfghjk");
		if (term[th]) {
			int l = len[th];
			long c = cost[th];
			set.add(new Pair(l, c));
		}
		while (termLink[th] != -1) {
			int l = len[th];
			long c = cost[th] + sumMin;
			set.add(new Pair(l, c));
			th = termLink[th];
		}
		ost[iterator] = set;
		for (int i = 0; i < ost.length; i++) {
			for (Pair p : ost[i]) {
				p.len--;
				p.c += sumMin - min[i];
			}
		}
		TreeSet<Pair> an = new TreeSet<>();
		for (int i = 0; i < ost.length; i++) {
			for (Pair p : ost[i]) {
				if (p.len >= 0 && (an.floor(p) == null || an.floor(p).len < p.len)) {
					an.add(p);
				}
			}
		}
		return an;
	}

	Edge[] father;
	ArrayList<Edge>[] edge;
	int[][] to;
	int[] link;
	boolean[] term;
	int[] termLink;
	int[] len;
	long[] cost;
	int numberInBor = 0;
	long[] ans;
//	long[] wasAns;
//	long[] left;
//	int time = 0;
//	int[] tin;

	public void solve() throws IOException {
		int n = nextInt();
		ans = new long[n];
		edge = new ArrayList[n];
		father = new Edge[n];
		for (int i = 0; i < edge.length; i++) {
			edge[i] = new ArrayList<>();
		}
		for (int i = 0; i < ans.length; i++) {
			ans[i] = Long.MAX_VALUE / 2;
		}
		for (int i = 0; i < ans.length; i++) {
			if (edge[i].size() == 0) {
				ans[i] = 0;
			}
		}
		int m = nextInt();
		int t = nextInt();
		int maxSz = 7;
		to = new int[maxSz][26];
		link = new int[maxSz];
		link[0] = -1;
		term = new boolean[maxSz];
		termLink = new int[maxSz];
		len = new int[maxSz];
		cost = new long[maxSz];
		int free = 1;
		for (int i = 0; i < to.length; i++) {
			termLink[i] = -1;
			cost[i] = Integer.MAX_VALUE;
			for (int j = 0; j < to[0].length; j++) {
				to[i][j] = -1;
			}
		}
		for (int i = 0; i < n - 1; i++) {
			int x = nextInt() - 1;
			i++;
			int l = nextToken().charAt(0) - 'a';
			father[i] = new Edge(x, l, i);
			edge[x].add(new Edge(i, l, i));
			i--;
		}
		for (int q = 0; q < m; q++) {
			long c = nextLong();
			String s = nextToken();
			int v = 0;
			for (int z = 0; z < s.length(); z++) {
				int l = s.charAt(z) - 'a';
				if (to[v][l] != -1) {
					v = to[v][l];
				} else {
					to[v][l] = free;
					// int li = link[v];
					// while (li > 0 && to[li][l] == -1) {
					// li = link[li];
					// }
					// if (li >= 0 && to[li][l] != -1) {
					// link[free] = to[li][l];
					// } else {
					// link[free] = 0;
					// }
					v = free;
					free++;
				}
				len[v] = z + 1;
			}
			term[v] = true;
			// if (term[link[v]]) {
			// termLink[v] = link[v];
			// } else {
			// termLink[v] = termLink[link[v]];
			// }
			cost[v] = Math.min(c, cost[v]);
		}
		Queue<Integer> q = new ArrayDeque<>();
		q.add(0);
		while (!q.isEmpty()) {
			int i = q.poll();
			for (int j = 0; j < to[0].length; j++) {
				if (to[i][j] != -1) {
					free = to[i][j];
					int li = link[i];
					while (li > 0 && to[li][j] == -1) {
						li = link[li];
					}
					if (li >= 0 && to[li][j] != -1) {
						link[free] = to[li][j];
					} else if (i > 0) {
						link[free] = 0;
					}
					q.add(free);
				}
			}
			if (i > 0) {
				if (term[link[i]]) {
					termLink[i] = link[i];
				} else {
					termLink[i] = termLink[link[i]];
				}
			}
		}
		dfs(0);
		out.print(ans[0]);
	}

	public void run() {
		try {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new D().run();
	}

}
