import java.io.*;
import java.util.*;

public class D1 {
    public void solve() throws IOException {
    		int n = nextInt();
    		int m = nextInt();
    		nextDouble();
    		long[] x = new long[26];
    		for (int i = 0; i < n - 1; i++) {
				nextDouble();
				x[nextToken().charAt(0) - 'a']++;
			}
    		long[] c = new long[26];
    		for (int i = 0; i < c.length; i++) {
				c[i] = Long.MAX_VALUE;
			}
    		for (int i = 0; i < c.length; i++) {
				long z = nextLong();
				int l = nextToken().charAt(0) - 'a';
				c[l] = Math.min(c[l], z);
			}
    		long ans = 0;
    		for (int i = 0; i < c.length; i++) {
				if (x[i] > 0 && c[i] == Long.MAX_VALUE) {
					System.out.println(-1);
					return;
				}
				ans += x[i] * c[i];
			}
    		System.out.println(ans);
    	}

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in)); 
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new D1().run();
    }

}
