import java.io.*;
import java.util.*;

public class C {
	
	public void dfs(int v, int l) {
		used[v] = true;
		len[v] = l;
		for (int i : to[v]) {
			if (!used[i]) {
				dfs(i, l + 1);
			}
		}
	}
	
	int[][] to;
	int[] len;
	boolean[] used;
	
    public void solve() throws IOException {
    	int n = nextInt();
    	long m = nextLong();
    	to = new int[n][];
    	len = new int[n];
    	used = new boolean[n];
    	int[] input = new int[n - 1];
    	int[] size = new int[n];
    	for (int i = 0; i < n - 1; i++) {
			input[i] = nextInt() - 1;
			size[i + 1]++;
			size[input[i]]++;
		}
    	for (int i = 0; i < size.length; i++) {
			to[i] = new int[size[i]];
			size[i] = 0;
		}
    	for (int i = 0; i < n - 1; i++) {
			int x = input[i];
    		to[x][size[x]] = (i + 1);
    		to[i + 1][size[i + 1]] = (x);
    		size[x]++;
    		size[i + 1]++;
		}
    	dfs(0, 0);
    	long h = 0;
    	int v = 0;
    	for (int i = 0; i < len.length; i++) {
			if (len[i] > h) {
				h = len[i];
				v = i;
			}
		}
    	len = new int[n];
    	used = new boolean[n];
    	dfs(v, 0);
    	long d = 0;
    	for (int i = 0; i < len.length; i++) {
			d = Math.max(d, len[i]);
		}
    	h++;
    	d++;
    	System.out.println(2 * (m - 1) * h + d);
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in)); 
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new C().run();
    }

}
