import java.io.*;
import java.util.*;

public class D5 {
	
	public class Point implements Comparable<Point> {
		int x;
		int c;
		
		public Point(int x, int c) {
			this.x = x;
			this.c = c;
		}

		@Override
		public int compareTo(Point arg0) {
			return x - arg0.x;
		}
	}
	
	public class buildReturn {
		HashSet<Integer> set;
		int ans;

		public buildReturn(HashSet<Integer> set, int ans) {
			this.set = set;
			this.ans = ans;
		}
	}
	
	public buildReturn build(int l, int r) {
//		int[] a = new int[m];
		if (line[last + 1].x > r) {
//			for (int i = 0; i < a.length; i++) {
//				a[i] = 2;
//			}
//			a[line[last].c] = 1;
			HashSet<Integer> set = new HashSet<>();
			set.add(line[last].c);
			if (line[last + 1].x == r + 1) {
				last++;
			}
//			System.out.println(l + " " + r + " " + 1);
//			for (int i : set) {
//				System.out.println(i);
//			}
			return new buildReturn(set, 1);
		}
		int m = (l + r) / 2;
		buildReturn b = build(l, m);
		buildReturn c = build(m + 1, r);
//		int minl = Integer.MAX_VALUE;
//		int minr = Integer.MAX_VALUE;
//		for (int i = 0; i < c.length; i++) {
//			minl = Math.min(minl, b[i]);
//			minr = Math.min(minr, c[i]);
//		}
		HashMap<Integer, Integer> map = new HashMap<>();
//		System.out.println(l + " " + r + " " + b.ans + " " + c.ans);
		for (int i : b.set) {
//			System.out.println(i);
			map.put(i, b.ans + (c.set.contains(i) ? c.ans - 1 : c.ans));
		}
		for (int i : c.set) {
//			System.out.println(i);
			if (!map.containsKey(i)) {
				map.put(i, c.ans + b.ans);
			}
		}
		int min = Integer.MAX_VALUE;
		for (int i : map.keySet()) {
//			System.out.println(i + " " + map.get(i) + "fghjkl");
			min = Math.min(min, map.get(i));
		}
		HashSet<Integer> set = new HashSet<>();
		for (int i : map.keySet()) {
			if (map.get(i) == min) {
				set.add(i);
			}
		}
//		System.out.println(l + " " + r + " " + min);
//		for (int i : set) {
//			System.out.println(i);
//		}
		return new buildReturn(set, min);
	}
	
	int k;
	int m;
	Point[] line;
	int last = 0;
	int ans = Integer.MAX_VALUE;
	
    public void solve() throws IOException {
    	k = nextInt();
    	int n = nextInt();
    	m = nextInt();
    	int x = 0;
    	line = new Point[n + 1];
    	for (int i = 0; i < n; i++) {
			int c = nextInt();
			line[i] = new Point(x, nextInt() - 1);
			x += c;
		}
    	line[n] = new Point(x, -1);
    	System.out.println(build(0, (1 << k) - 1).ans);
//    	int[] a = build(0, (1 << k) - 1);
//    	for (int i : a) {
//			ans = Math.min(ans, i);
//		}
//    	System.out.println(ans);
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in) /*new FileReader(new File("input.txt"))*/); 
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new D5().run();
    }

}
